package cn.bsl.bxbg.zhiban.view;

import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.TextView;
import android.widget.Toast;

import java.util.List;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;
import cn.bsl.bxbg.zhiban.BaseActivity;
import cn.bsl.bxbg.zhiban.R;
import cn.bsl.bxbg.zhiban.net.client.DutyPlanClient;
import cn.bsl.bxbg.zhiban.net.response.CCDutiesEdit;
import cn.bsl.bxbg.zhiban.net.response.CCShifts;
import cn.bsl.bxbg.zhiban.net.response.CCShiftsUni;
import cn.bsl.bxbg.zhiban.net.response.DutiesTbResponse;
import cn.bsl.bxbg.zhiban.utils.Constant;
import io.reactivex.ObservableSource;
import io.reactivex.android.schedulers.AndroidSchedulers;
import io.reactivex.functions.Consumer;
import io.reactivex.functions.Function;
import io.reactivex.schedulers.Schedulers;

public class TiaobanDetailsActivity extends BaseActivity {

    @BindView(R.id.duty_times)
    TextView dutyTimes;
    @BindView(R.id.person)
    TextView person;
    @BindView(R.id.change_person)
    TextView changePerson;
    @BindView(R.id.reason)
    TextView reason;
    @BindView(R.id.agree)
    RadioButton agree;
    @BindView(R.id.disagree)
    RadioButton disagree;
    @BindView(R.id.submit)
    Button submit;
    @BindView(R.id.isAgreen)
    LinearLayout isAgreen;
    @BindView(R.id.rg)
    RadioGroup rg;
    @BindView(R.id.tv_status)
    TextView tvStatus;
    private String id;
    DutyPlanClient dutyPlanClient = new DutyPlanClient();
    String status = "1";
    private String ccShift_id;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_tiaoban_details);
        ButterKnife.bind(this);
        initData();
        initView();
    }

    private void initData() {
        id = getIntent().getStringExtra("id");
        dutyPlanClient.dutiesTbDetails(id)
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new Consumer<List<DutiesTbResponse>>() {
                    @Override
                    public void accept(List<DutiesTbResponse> dutiesTbResponses) throws Exception {
                        ccShift_id = dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getId();
                        String createTime = dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getCreateTime();
                        String dutyDate = dutiesTbResponses.get(0).getSuperior().getDutyDate();
                        String people = " 早：" + dutiesTbResponses.get(0).getSuperior().getMorning() + "\n 中:" + dutiesTbResponses.get(0).getSuperior().getNoon() + "\n 晚:" + dutiesTbResponses.get(0).getSuperior().getEvening();
                        String change = dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getTransferredName() + " 变更为 " + dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getTransferredClass();
                        dutyTimes.setText(dutyDate);
                        person.setText(people);
                        changePerson.setText(change);
                        // simple if 换班人是我判断id 如果被换班是我 直接修改
                        if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getTransferredName().equals(Constant.USER_NAME)) {

                            if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getStatus().equals("0")) {
                                tvStatus.setText("调班状态：等待对方操作");
                                rg.setVisibility(View.GONE);
                                submit.setVisibility(View.GONE);
                            } else if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getStatus().equals("1")) {
                                tvStatus.setVisibility(View.VISIBLE);
                                tvStatus.setText("调班状态：对方同意了您的申请");
                                rg.setVisibility(View.GONE);
                                submit.setVisibility(View.GONE);
                            } else if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getStatus().equals("2")) {
                                tvStatus.setVisibility(View.VISIBLE);
                                tvStatus.setText("调班状态：对方不同意您的申请");
                                rg.setVisibility(View.GONE);
                                submit.setVisibility(View.GONE);
                            }
                        } else if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getTransferredClass().equals(Constant.USER_NAME)) {
                            // 被换班人是我
                            if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getStatus().equals("0")) {
                                tvStatus.setVisibility(View.GONE);
                            } else if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getStatus().equals("1")) {
                                tvStatus.setVisibility(View.VISIBLE);
                                tvStatus.setText("调班状态：您同意了对方申请");
                                rg.setVisibility(View.GONE);
                                submit.setVisibility(View.GONE);
                            } else if (dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getStatus().equals("2")) {
                                tvStatus.setVisibility(View.VISIBLE);
                                tvStatus.setText("调班状态：您不同意了对方申请");
                                rg.setVisibility(View.GONE);
                                submit.setVisibility(View.GONE);
                            }
                        }
                        reason.setText(dutiesTbResponses.get(0).getRefers().getCc_shift().get(0).getReason());
                    }
                }, Throwable::printStackTrace);

    }

    private void initView() {
        rg.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            @Override
            public void onCheckedChanged(RadioGroup radioGroup, int i) {
                switch (radioGroup.getId()) {
                    case R.id.agree:
                        // 修改status
                        // 改值班表
                        status = "1";
                        break;
                    case R.id.disagree:
                        // 修改status
                        //
                        status = "2";
                        break;
                }
            }
        });
    }

    @OnClick(R.id.submit)
    public void onViewClicked() {

        if (status.equals("1")) {
            dutyPlanClient.ccShiftsEdit(ccShift_id,status).flatMap(new Function<CCShifts, ObservableSource<List<CCShiftsUni>>>() {
                @Override
                public ObservableSource<List<CCShiftsUni>> apply(CCShifts ccShifts) throws Exception {
                    return dutyPlanClient.ccshiftUni(id);
                }
            }).flatMap(new Function<List<CCShiftsUni>, ObservableSource<CCDutiesEdit>>() {
                @Override
                public ObservableSource<CCDutiesEdit> apply(List<CCShiftsUni> ccShiftsUnis) throws Exception {
                    if (ccShiftsUnis.get(0).getSuperior().getTransferredClassTime().equals("0")) {
                        String morning = ccShiftsUnis.get(0).getIncludes().getCc_duty().getMorning();
                        return dutyPlanClient.editMorning(id, morning.replace(Constant.USER_NAME, ccShiftsUnis.get(0).getSuperior().getTransferredClass()));
                    } else if (ccShiftsUnis.get(0).getSuperior().getTransferredClassTime().equals("1")) {
                        String noon = ccShiftsUnis.get(0).getIncludes().getCc_duty().getNoon();
                        return dutyPlanClient.editNoon(id, noon.replace(Constant.USER_NAME, ccShiftsUnis.get(0).getSuperior().getTransferredClass()));
                    } else {
                        String eve = ccShiftsUnis.get(0).getIncludes().getCc_duty().getEvening();
                        return dutyPlanClient.editNight(id, eve.replace(Constant.USER_NAME, ccShiftsUnis.get(0).getSuperior().getTransferredClass()));
                    }
                }
            }).subscribeOn(Schedulers.io())
            .observeOn(AndroidSchedulers.mainThread())
            .subscribe(ccDutiesEdit -> {
                Toast.makeText(TiaobanDetailsActivity.this, "操作成功", Toast.LENGTH_SHORT).show();
                finish();
            },Throwable::printStackTrace);
        } else {
            dutyPlanClient.ccShiftsEdit(id,status).subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread()).subscribe(ccShifts -> {
                Toast.makeText(TiaobanDetailsActivity.this, "操作成功", Toast.LENGTH_SHORT).show();
                finish();
            }, Throwable::printStackTrace);
        }
    }
}
